#include "mainloop.h"
#include "d12ci.h"

#define D12_COMMAND	0x400004
#define D12_DATA	0x400000

/* * f[^|[g񖽗ߘAœǂݍނƁAlǂݏo܂B
 *   Ⴆ΁Â悤ȃR[hƁAȂȂ܂B
 *	xld.w %r0, 0x400000
 *	xld.w %r1, [%r0]
 *	xld.w %r2, [%r0]
 *   D12_ReadEndpoint()ł́A_~[ƃTCY̓ǂݍ݂Ȃǂ댯łB
 * * ͕słACPU`USBCւCE7MɊ܂܂ĂA
 *   fBCHł͂ȂƎv܂B
 *   (KvȃfBCȂ̂ł傤ǁÂԂɉeoĂ?)
 * * ۂɂ́Ainportb()֐ĂяõI[o[wbĥŁA
 *   ̂悤ȃR[h邱Ƃ͂ȂƎv܂A
 *   YȂ悤(Ô߂)AInop͂ނƂɂ܂B
 *	xld.w %r0, 0x400000
 *	xld.w %r1, [%r0]
 *	nop I
 *	xld.w %r2, [%r0]
 *	nop I
 * * f[^|[gւ̓Aߏ݂͌؂Ă܂񂪁A
 *   Ԃ񓯂soƎv̂ŁAnopނƂɂ܂B
 */

static void
outportb(unsigned long port, unsigned char val)
{
	*(volatile unsigned char*)port = val;
	asm("nop"); /* KvI */
}

static unsigned char
inportb(unsigned long port)
{
	unsigned char val;
	val = *(volatile unsigned char*)port;
	asm("nop"); /* KvI */
	return val;
}


/******** Initialization commands ********/

void
D12_SetAddressEnable(unsigned char addr, unsigned char enable)
{
	outportb(D12_COMMAND, 0xD0);
	if(enable) addr |= 0x80;
	outportb(D12_DATA, addr);
}

void
D12_SetEndpointEnable(unsigned char enable)
{
	outportb(D12_COMMAND, 0xD8);
	outportb(D12_DATA, enable);
}

void
D12_SetMode(unsigned char config, unsigned char clkdiv)
{
	outportb(D12_COMMAND, 0xF3);
	outportb(D12_DATA, config);
	outportb(D12_DATA, clkdiv);
}

void
D12_SetDMA(unsigned char mode)
{
	outportb(D12_COMMAND, 0xFB);
	outportb(D12_DATA, mode);
}

/******** Data flow commands ********/

unsigned short
D12_ReadInterruptRegister()
{
	unsigned char lo, hi;

	outportb(D12_COMMAND, 0xF4);
	lo = inportb(D12_DATA);
	hi = inportb(D12_DATA);

	return hi << 8 | lo;
}

unsigned char
D12_SelectEndpoint(unsigned char endp)
{
	outportb(D12_COMMAND, 0x00 | endp);
	return inportb(D12_DATA);
}

unsigned char
D12_ReadLastTransactionStatus(unsigned char endp)
{
	outportb(D12_COMMAND, 0x40 | endp);
	return inportb(D12_DATA);
}

unsigned char
D12_ReadEndpointStatus(unsigned char endp)
{
	outportb(D12_COMMAND, 0x80 | endp);
	return inportb(D12_DATA);
}

int
D12_ReadEndpoint(unsigned char endp, void* buf, unsigned char maxlen)
{
	unsigned char* dst = (unsigned char*)buf;
	unsigned char i, dummy, len;

	/* ǂݍރGh|CgI܂B
	 * MĂȂ΁A܂ǂݍ߂܂B
	 * * D12_FULLEMPTY=1M(FULL)Ӗ܂B
	 *   EMPTY(D12_FULLEMPTY=0)Ƃ͋tȂ̂ŁAӂĂB
	 */
	if(!(D12_SelectEndpoint(endp) & D12_FULLEMPTY)) return 0;

	/* Mf[^ǂݍ݂܂B */
	outportb(D12_COMMAND, 0xF0);
	dummy = inportb(D12_DATA); /* _~[ */
	len   = inportb(D12_DATA); /* MoCg */
	if(len > maxlen) len = maxlen; /* ǂݍ݃oCg؂l */
	for(i = 0; i < len; i++) dst[i] = inportb(D12_DATA);

	/* Mobt@ɂ܂B */
	outportb(D12_COMMAND, 0xF2); /* = Clear Buffer */

	return len;
}

int
D12_WriteEndpoint(unsigned char endp, void* buf, unsigned char len)
{
	unsigned char* src = (unsigned char*)buf;
	unsigned char i;

#if 0
	/* ރGh|CgI܂B
	 * MĂȂ΁A܂߂܂B
	 * * D12_FULLEMPTY=0M(EMPTY)Ӗ܂B
	 *   FULL(D12_FULLEMPTY=1)Ƃ͋tȂ̂ŁAӂĂB
	 */
	if(D12_SelectEndpoint(endp) & D12_FULLEMPTY) return 0;
#else
	/* C^vg]Ŗ]f[^j邱Ƃ悤Ȃ̂ŁA
	 * EMPTY͂߂܂B
	 */
	D12_SelectEndpoint(endp);
#endif

	outportb(D12_COMMAND, 0xF0);
	outportb(D12_DATA,   0); /* _~[ */
	outportb(D12_DATA, len); /* MoCg */
	for(i = 0; i < len; i++) outportb(D12_DATA, src[i]);

	/* MJn܂B */
	outportb(D12_COMMAND, 0xFA); /* = Validate Buffer */

	return len;
}

void
D12_SetEndpointStatus(unsigned char endp, unsigned char stall)
{
	outportb(D12_COMMAND, 0x40 | endp);
	outportb(D12_DATA, stall);
}

void
D12_AcknowledgeSetup(unsigned char endp)
{
	outportb(D12_COMMAND, endp);
	outportb(D12_COMMAND, 0xF1);

	/* D12_AcknowledgeSetup()ɐ旧D12_ReadEndpoint()Ă΂ĂƎv܂A
	 * D12_ReadEndpoint()̒ōsClear Buffer͖łB
	 * EP0łSETUPM`Acknowledge SetupԂClear/Validate BufferłB
	 * Acknowledge SetupɂClear Buffers܂B(x͗Lł)
	 */
	if(endp == 0) outportb(D12_COMMAND, 0xF2); /* = Clear Buffer */
}

/******** General commands ********/

void
D12_SendResume()
{
	outportb(D12_COMMAND, 0xF6);
}

unsigned short
D12_ReadCurrentFrameNumber()
{
	unsigned char lo, hi;

	outportb(D12_COMMAND, 0xF5);
	lo = inportb(D12_DATA);
	hi = inportb(D12_DATA);

	return hi << 8 | lo;
}

/******** Undocumented commands ********/

unsigned short
D12_ReadChipID()
{
	unsigned short lo, hi;

	outportb(D12_COMMAND, 0xFD);
	lo = inportb(D12_DATA);
	hi = inportb(D12_DATA);

	return hi << 8 | lo;
}
