#ifndef __D12CI_H__
#define __D12CI_H__

/* D12_SetMode(config) */
#define D12_NOLAZYCLOCK			0x02
#define D12_CLOCKRUNNING		0x04
#define D12_INTERRUPTMODE		0x08
#define D12_SOFTCONNECT			0x10
#define D12_ENDP_NONISO			0x00
#define D12_ENDP_ISOOUT			0x40
#define D12_ENDP_ISOIN			0x80
#define D12_ENDP_ISOIO			0xC0
/* D12_SetMode(clkdiv) */
#define D12_CLOCK_12M			0x03
#define D12_CLOCK_4M			0x0b
#define D12_SETTOONE			0x40
#define D12_SOFONLY			0x80
/* D12_SetDMA(mode) */
#define D12_DMASINGLE			0x00
#define D12_BURST_4			0x01
#define D12_BURST_8			0x02
#define D12_BURST_16			0x03
#define D12_DMAENABLE			0x04
#define D12_DMA_INTOKEN			0x08
#define D12_AUTOLOAD			0x10
#define D12_NORMALPLUSSOF		0x20
#define D12_ENDP4INTENABLE		0x40
#define D12_ENDP5INTENABLE		0x80
/* D12_ReadInterruptRegister(retval) */
#define D12_INT_ENDP0OUT		0x01
#define D12_INT_ENDP0IN			0x02
#define D12_INT_ENDP1OUT		0x04
#define D12_INT_ENDP1IN			0x08
#define D12_INT_ENDP2OUT		0x10
#define D12_INT_ENDP2IN			0x20
#define D12_INT_BUSRESET		0x40
#define D12_INT_SUSPENDCHANGE		0x80
#define D12_INT_EOT			0x0100
/* D12_ReadLastTransactionStatus(retval) */
#define D12_SETUPPACKET			0x20
/* D12_ReadEndpointStatus(retval) */
#define D12_BUFFER0FULL			0x20
#define D12_BUFFER1FULL			0x40
/* D12_SelectEndpoint(retval) */
#define D12_FULLEMPTY			0x01
#define D12_STALL			0x02

/******** Initialization commands ********/
void D12_SetAddressEnable(unsigned char addr, unsigned char enable);
void D12_SetEndpointEnable(unsigned char enable);
void D12_SetMode(unsigned char config, unsigned char clkdiv);
void D12_SetDMA(unsigned char mode);
/******** Data flow commands ********/
unsigned short D12_ReadInterruptRegister();
unsigned char D12_SelectEndpoint(unsigned char endp);
unsigned char D12_ReadLastTransactionStatus(unsigned char endp);
unsigned char D12_ReadEndpointStatus(unsigned char endp);
int D12_ReadEndpoint(unsigned char endp, void* buf, unsigned char maxlen);
int D12_WriteEndpoint(unsigned char endp, void* buf, unsigned char len);
void D12_SetEndpointStatus(unsigned char endp, unsigned char stall);
void D12_AcknowledgeSetup(unsigned char endp);
/******** General commands ********/
void D12_SendResume();
unsigned short D12_ReadCurrentFrameNumber();
/******** Undocumented commands ********/
unsigned short D12_ReadChipID();

#endif /*__D12CI_H__*/
